// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBPANELAPPLETMM_APPLET_H
#define _LIBPANELAPPLETMM_APPLET_H

#include <glibmm.h>

/* Copyright 2003 libpanelappletmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <panel-applet.h>
#include <panel-applet-gconf.h>

#include <libpanelappletmm/enums.h>
#include <libpanelappletmm/types.h>
#include <gtkmm/eventbox.h>

#include <glibmm.h>

#include <gdkmm/color.h>
#include <gdkmm/pixmap.h>

#include <gconfmm/value.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _PanelApplet PanelApplet;
typedef struct _PanelAppletClass PanelAppletClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Panel
{ class Applet_Class; } // namespace Panel

} // namespace Gnome
namespace Gnome
{

namespace Panel
{


class Applet : public Gtk::EventBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Applet CppObjectType;
  typedef Applet_Class CppClassType;
  typedef PanelApplet BaseObjectType;
  typedef PanelAppletClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Applet();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Applet_Class;
  static CppClassType applet_class_;

  // noncopyable
  Applet(const Applet&);
  Applet& operator=(const Applet&);

protected:
  explicit Applet(const Glib::ConstructParams& construct_params);
  explicit Applet(PanelApplet* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  PanelApplet*       gobj()       { return reinterpret_cast<PanelApplet*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const PanelApplet* gobj() const { return reinterpret_cast<PanelApplet*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_change_orientation(AppletOrient orient);
  virtual void on_change_size(int size);
  virtual void on_change_background(AppletBackgroundType type, const Gdk::Color & color, const Glib::RefPtr<const Gdk::Pixmap>& pixmap);
  virtual void on_move_focus_out_of_applet(Gtk::DirectionType direction);


private:

  
public:

  Applet();

  
  /**
   * @par Prototype:
   * <tt>void %change_orientation(AppletOrient orient)</tt>
   */
  Glib::SignalProxy1<void,AppletOrient> signal_change_orientation();

  
  /**
   * @par Prototype:
   * <tt>void %change_size(int size)</tt>
   */
  Glib::SignalProxy1<void,int> signal_change_size();

  
  /**
   * @par Prototype:
   * <tt>void %change_background(AppletBackgroundType type, const Gdk::Color & color, const Glib::RefPtr<const Gdk::Pixmap>& pixmap)</tt>
   */
  Glib::SignalProxy3<void,AppletBackgroundType,const Gdk::Color &,const Glib::RefPtr<const Gdk::Pixmap>&> signal_change_background();

  
  /**
   * @par Prototype:
   * <tt>void %move_focus_out_of_applet(Gtk::DirectionType direction)</tt>
   */
  Glib::SignalProxy1<void,Gtk::DirectionType> signal_move_focus_out_of_applet();


  AppletOrient get_orientation() const;
  
  int get_size() const;
 
  //color and pixmap are output variables. TODO: Document this method properly, as if it had been wrapped automaticaly
  AppletBackgroundType get_background(Gdk::Color& color, Glib::RefPtr<Gdk::Pixmap>& pixmap) const;
  

  Glib::ustring get_preferences_key() const;
  
  void add_preferences(const Glib::ustring& schema_dir);
  
  AppletFlags get_flags() const;
  
  void set_flags(AppletFlags flags);

  void set_size_hints(const Glib::ArrayHandle<int>& size_hints, int base_size);

  
  BonoboControl* get_control();
  
  const BonoboControl* get_control() const;
  
  BonoboUIComponent* get_popup_component();
  
  const BonoboUIComponent* get_popup_component() const;
  
  void setup_menu(const Glib::ArrayHandle<Glib::ustring>& xml, const BonoboUIVerb* verb_list, gpointer user_data);
  
  void setup_menu(const Glib::ustring& xml, const BonoboUIVerb* verb_list, gpointer user_data);
  
  void setup_menu(const Glib::ustring& opt_datadir, const Glib::ustring& file, const Glib::ustring& opt_app_name, const BonoboUIVerb* verb_list, gpointer user_data);
  
  
  Glib::ustring gconf_get_full_key(const Glib::ustring& key) const;
  
  void gconf_set(const Glib::ustring& key, bool the_bool);
  
  void gconf_set(const Glib::ustring& key, int the_int);
  
  void gconf_set(const Glib::ustring& key, const Glib::ustring& the_string);
  
  void gconf_set(const Glib::ustring& key, double the_float);
  
  void gconf_set(const Glib::ustring& key, const Gnome::Conf::Value& value);
  
  
  bool gconf_get_bool(const Glib::ustring& key) const;
  
  int gconf_get_int(const Glib::ustring& key) const;
  
  Glib::ustring gconf_get_string(const Glib::ustring& key) const;
  
  double gconf_get_float(const Glib::ustring& key) const;
  
  Gnome::Conf::Value gconf_get_value(const Glib::ustring& key) const;

  //TODO: there has to be a way to do a template function for this, right? -Bryan
  void gconf_set_list(const Glib::ustring& key, const Gnome::Conf::SListHandle_ValueBool& list);
  void gconf_set_list(const Glib::ustring& key, const Gnome::Conf::SListHandle_ValueInt& list);
  void gconf_set_list(const Glib::ustring& key, const Gnome::Conf::SListHandle_ValueString& list);
  void gconf_set_list(const Glib::ustring& key, const Gnome::Conf::SListHandle_ValueFloat& list);

  Gnome::Conf::SListHandle_ValueBool   gconf_get_bool_list(const Glib::ustring& key) const;
  Gnome::Conf::SListHandle_ValueInt    gconf_get_int_list(const Glib::ustring& key) const;
  Gnome::Conf::SListHandle_ValueString gconf_get_string_list(const Glib::ustring& key) const;
  Gnome::Conf::SListHandle_ValueFloat  gconf_get_float_list(const Glib::ustring& key) const;


};

} // namespace Panel
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Panel::Applet */
  Gnome::Panel::Applet* wrap(PanelApplet* object, bool take_copy = false);
}
#endif /* _LIBPANELAPPLETMM_APPLET_H */

